require "fit/Fixture"
require "fit/TypeAdapter"

# Copyright (c) 2002 Cunningham & Cunningham, Inc.
# Released under the terms of the GNU General Public License version 2 or later.

module Fit

  class ActionFixture < Fixture 

#    protected Parse cells;
#    public static Fixture actor;
#    protected static Class empty[] = {};

    # Traversal ////////////////////////////////

    def do_cells(cells)
      @cells = cells
      begin
	send(cells.text)
      rescue Exception => e
	Fixture.exception(cells, e)
      end
    end

    # Actions //////////////////////////////////

    def start
      klass = Fixture.get_class(@cells.more.text)
      @actor = klass.new
    end

    # we allow enter to be called on methods with a single
    # argument, or with a setter (name=) method
    def enter
      method_name = @cells.more.text
      param = @cells.more.more.text
      adapter = TypeAdapter.for(@actor, method_name, false)
      meth = @actor.method(method_name)
      arg = adapter.parse(param)
      if meth.arity == 1
	@actor.send(method_name, arg)
      else
	adapter.set(arg)
      end
    end

    def press
      method_name = @cells.more.text
      @actor.send(method_name)
    end

    def check
      method_name = @cells.more.text
      adapter = TypeAdapter.for(@actor, method_name, false)
      super(@cells.more.more, adapter)
    end

  end
end
