require 'fit/Fixture'
require 'fit/TypeAdapter'


module Fit

# Copyright (c) 2002 Cunningham & Cunningham, Inc.
# Released under the terms of the GNU General Public License version 2 or later.


  class ColumnFixture < Fixture


#    protected TypeAdapter columnBindings[];
#    protected boolean hasExecuted = false;

    # Traversal ////////////////////////////////

    def do_rows(rows) 
      bind(rows.parts)
      super(rows.more)
    end


    def do_row(row)
      @has_executed = false;
      begin
	reset
      rescue Exception => e
	Fixture.exception(row.leaf, e)
      end
      super
    end

    def do_cell(cell, column)
      adapter = @column_bindings[column]
      begin
	text = cell.text
	if text.empty?
	  # skip cell
	elsif adapter.nil?
	  Fixture.ignore(cell)
	elsif adapter.is_output?
	  check(cell, adapter)
	else
	  adapter.set(adapter.parse(text))
	end
      rescue Exception => e
	Fixture.exception(cell, e)
      end
        
    end

    def check(cell, adaptor) 
      unless @has_executed
	begin
	  execute()
	rescue Exception => e
	  Fixture.exception(cell, e)
	ensure
	  @has_executed = true
        end
        super
      end
    end

    def reset
      # about to process first cell of row
    end

    def execute
      # about to execute first method call of a row
    end


    private

    def bind(heads)
      @column_bindings = []
      while heads
	name = heads.text
	output = false

	if name =~ /\(\)$/
	  name = name[0..-3]
	  output = true
	end

	if name.empty?
	  @column_bindings << nil
	else
	  begin
	    @column_bindings << TypeAdapter.for(self, name, output)
	  rescue Exception => e
	    Fixture.exception(heads, e)
	  end
	end
	heads = heads.more
      end
    end

=begin
    protected TypeAdapter bindMethod (String name) throws Exception {
        return TypeAdapter.on(this, getTargetClass().getMethod(name, new Class[]{}));
    }

    protected TypeAdapter bindField (String name) throws Exception {
        return TypeAdapter.on(this, getTargetClass().getField(name));
    }

    protected Class getTargetClass() {
        return getClass();
    }

}
=end
end
end
