# Copyright (c) 2002 Cunningham & Cunningham, Inc.
# Released under the terms of the GNU General Public License version 2 or later.

require "fit/Fixture"

module Fit


  class Summary < Fit::Fixture 

    COUNTS = "counts"

    def do_table(table)
      summary[COUNTS] = Fixture.counts
      table.parts.more = rows(summary.keys.sort)
    end

    def rows(keys)
      return nil if keys.empty?
      key = keys.shift
      result = tr(td(key.to_s,
		     td(summary[key].to_s,
			nil)),
		  rows(keys))
            mark(result) if key == COUNTS
      result
    end


    def tr(parts, more) 
        ParseHolder.create("tr", nil, parts, more)
    end

    def td(body, more)
      ParseHolder.create("td", body, nil, more)
    end

    protected

    # mark summary good/bad without counting
    def mark(row) 
      cell = row.parts.more
      if Fixture.total_errors > 0
	Fixture.wrong(cell, nil, false)
      else
	Fixture.right(cell, false)
      end
    end
  end
end
